searchNodes=[{"doc":"This lib implements a set of methods to help you handle the storage and access to database-backend sessions with ecto. In your application, use EctoSessions : defmodule MyApp.Sessions do use EctoSessions , repo : MyApp.Repo , prefix : nil , table_name : &quot;sessions&quot; , extra_fields : [ field : [ :user_id , :string ] ] end Parameters: repo : your ecto repo module, required. Ex: MyApp.Repo . prefix : ecto prefix, optional, default to nil . table_name : The table name for these sessions. Create a module using EctoSessions for each table, ex: Sessions, ApiKeys, etc. extra_fields : Extra, custom, high-level, fields (columns) for the session schema. See EctoSessions.Migrations for instructions on how to migrate your database.","ref":"EctoSessions.html","title":"EctoSessions","type":"behaviour"},{"doc":"Count the sessions matching the provided filters.","ref":"EctoSessions.html#c:count/1","title":"EctoSessions.count/1","type":"callback"},{"doc":"Creates a session. attrs is a map that contains EctoSessions.Session attributes, where the keys are atoms. Uses Ecto.Repo.insert Examples iex&gt; create_session ( %{ user_id : &quot;1234&quot; , data : %{ device_name : &quot;Sample Browser&quot; } } ) % Session { user_id : &quot;1234&quot; , data : %{ device_name : &quot;Sample Browser&quot; , auth_token : &quot;plaintext-auth-token&quot; auth_token_digest : &quot;hashed-token&quot; } }","ref":"EctoSessions.html#c:create_session/1","title":"EctoSessions.create_session/1","type":"callback"},{"doc":"Same as create_session/1 but using Ecto.Repo.insert! .","ref":"EctoSessions.html#c:create_session!/2","title":"EctoSessions.create_session!/2","type":"callback"},{"doc":"Deletes expired sessions.","ref":"EctoSessions.html#c:delete_expired/1","title":"EctoSessions.delete_expired/1","type":"callback"},{"doc":"Deletes the session using Ecto.Repo.delete .","ref":"EctoSessions.html#c:delete_session/1","title":"EctoSessions.delete_session/1","type":"callback"},{"doc":"Deletes the session using Ecto.Repo.delete! .","ref":"EctoSessions.html#c:delete_session!/1","title":"EctoSessions.delete_session!/1","type":"callback"},{"doc":"Given a session, ensure expires_at is updated according to the EctoSessions.Config .","ref":"EctoSessions.html#c:extend_session/1","title":"EctoSessions.extend_session/1","type":"callback"},{"doc":"Filters a session query.","ref":"EctoSessions.html#c:filter_session_query/2","title":"EctoSessions.filter_session_query/2","type":"callback"},{"doc":"Filters a session query by the given argument.","ref":"EctoSessions.html#c:filter_session_query_by/2","title":"EctoSessions.filter_session_query_by/2","type":"callback"},{"doc":"Retrieves a session from the database. Options: preload : ecto preloads, see get_sessions_query/1 . auto_extend_session : override the default auto_extend_session config ( Config.get_auto_extend_session() ). true will perform session extending, false to prevent this behaviour.","ref":"EctoSessions.html#c:get_session/2","title":"EctoSessions.get_session/2","type":"callback"},{"doc":"Retrieves a session from the database using Ecto.Repo.one! See get_session/2 for more information.","ref":"EctoSessions.html#c:get_session!/2","title":"EctoSessions.get_session!/2","type":"callback"},{"doc":"Retrieves a query to the sessions. Options: delete_query : Boolean that indicates a delete query a should be returned. Instead of a select one (the default: false). preload : Shorthand for preload query argument.","ref":"EctoSessions.html#c:get_sessions_query/1","title":"EctoSessions.get_sessions_query/1","type":"callback"},{"doc":"Retrieve sessions matching the provided filters.","ref":"EctoSessions.html#c:list_sessions/2","title":"EctoSessions.list_sessions/2","type":"callback"},{"doc":"Retrieve valid sessions matching the provided filters.","ref":"EctoSessions.html#c:list_valid_sessions/2","title":"EctoSessions.list_valid_sessions/2","type":"callback"},{"doc":"Updates a session using Ecto.Repo.update! .","ref":"EctoSessions.html#c:update_session!/1","title":"EctoSessions.update_session!/1","type":"callback"},{"doc":"This module handles the generation and hashing of auth tokens. Auth token is a cryptographically random string used for Authorization.","ref":"EctoSessions.AuthToken.html","title":"EctoSessions.AuthToken","type":"module"},{"doc":"Generates a cryptographically random auth token. length is a positive integer that will dictate the length of the token. For authentication purposes it should not be lower than 32. The token will contain characters from A-z , 0-9 plus _ and - . The number of unique possible strings (entropy) can be calculated as 64^length .","ref":"EctoSessions.AuthToken.html#generate_token/1","title":"EctoSessions.AuthToken.generate_token/1","type":"function"},{"doc":"Given an auth token, hashes it and salts it. Hashing and salting can be disabling passng nil . But salting only works when hashing is enabled. See hash ad add_salt for further reference. Examples iex&gt; get_digest ( &quot;sample&quot; , nil , nil ) &quot;sample&quot; iex&gt; get_digest ( &quot;sample&quot; , :sha256 , nil ) &quot;af2bdbe1aa9b6ec1e2ade1d694f41fc71a831d0268e9891562113d8a62add1bf&quot; iex&gt; get_digest ( &quot;sample&quot; , :sha256 , &quot;your-secret-salt&quot; ) &quot;709a5d6cba7d3162a1035b0a9cd13064ee4cbe4587cbcc4e378d831e728310c7&quot;","ref":"EctoSessions.AuthToken.html#get_digest/3","title":"EctoSessions.AuthToken.get_digest/3","type":"function"},{"doc":"Hashes a token with the provided hashing algorithm. Uses erlang's :cripto module. hashing_algorithm can be: :sha :sha224 :sha256 :sha384 :sha512 :sha3_224 :sha3_256 :sha3_384 :sha3_512 :blake2b :blake2s :ripemd160 nil to not hash, and store tokens in plaintext - not recommended; See erlang's crypto's hash_algorithm() for more information Examples iex&gt; hash ( &quot;sample&quot; , nil ) &quot;sample&quot; iex&gt; hash ( &quot;sample&quot; , :sha256 ) &quot;af2bdbe1aa9b6ec1e2ade1d694f41fc71a831d0268e9891562113d8a62add1bf&quot; iex&gt; hash ( &quot;sample&quot; , :sha256 ) &quot;af2bdbe1aa9b6ec1e2ade1d694f41fc71a831d0268e9891562113d8a62add1bf&quot; iex&gt; hash ( &quot;sample&quot; , :sha512 ) &quot;39a5e04aaff7455d9850c605364f514c11324ce64016960d23d5dc57d3ffd8f4&quot; &lt;&gt; &quot;9a739468ab8049bf18eef820cdb1ad6c9015f838556bc7fad4138b23fdf986c7&quot; iex&gt; hash ( &quot;sample&quot; , :sha3_256 ) &quot;f68f564e181663381ef67ae5849d3dd1d0f1044cf468d0a0b7875e4ff121906f&quot; iex&gt; hash ( &quot;sample&quot; , :nil ) &quot;sample&quot;","ref":"EctoSessions.AuthToken.html#hash/2","title":"EctoSessions.AuthToken.hash/2","type":"function"},{"doc":"Appends a global, secret salt to the given token. Sometimes referred as pepper . Examples iex&gt; salt ( &quot;sample&quot; , nil ) &quot;sample&quot; iex&gt; salt ( &quot;sample&quot; , &quot;your-secret-salt&quot; ) &quot;your-secret-saltsample&quot;","ref":"EctoSessions.AuthToken.html#salt/2","title":"EctoSessions.AuthToken.salt/2","type":"function"},{"doc":"This module handles ecto_sessions runtime configuration. In your runtime.exs / config.exs : config :your_app , MyApp.EctoSessions , auth_token_length : 128 , hashing_algorithm : :sha512 , secret_salt : &quot;my-unique-secret&quot; , session_ttl : 60 * 60 * 24 , extend_session_stale_time : 60 * 60 * 6 , auto_extend_session : true Configuration options auth_token_length The length of the session auth token (from auth_token_length application env). Defaults to 64 . Can be changed at any time, applies for new sessions only. hashing_algorithm The hashing algorithm to use (from hashing_algorithm application env). Can be one of the following: :sha :sha224 :sha256 (the default) :sha384 :sha512 :sha3_224 :sha3_256 :sha3_384 :sha3_512 :blake2b :blake2s :ripemd160 nil to not hash, and store tokens in plaintext; See erlang's crypto hash_algorithm() for more information. secret_salt The Optional secret salt , commonly known as pepper to be added to the auth token before hashing. Runtime configuration. Once changed, invalidates all sessions, as lookup is no longer possible. Can only be set if hashing_algorithm is not nil . Set to nil to not salt auth_tokens. Defaults to nil . session_ttl For how many should the session be valid. Both since its creation or when extended. Runtime configuration from session_ttl , defaults to 7 days ( 60 * 60 * 24 * 7 ). extend_session_stale_time The number of seconds from the session_ttl to consider the session as needing to be extended, it is a threshold, to keep the value unchanged. This prevents constant update of the session expires_at . When this threshold has been met, the Session's expires_at will be updated to now plus the session_ttl . Set to nil to prevent session extending, and 0 to extend it every time. Session extending is attempted (if enabled), when: Calling EctoSessions.get_session or EctoSessions.get_session! when the config auto_extend_session is true . Calling EctoSessions.get_session or EctoSessions.get_session! and passing the option :should_extend_session as true (overrides the default). Manually calling EctoSessions.extend_session . Manual update passing tru Session.changeset is called. Runtime configuration. Defaults to 1 day ( 60 * 60 * 24 ). Must be lower than session_ttl . auto_extend_session The default value for the :should_extend_session option, used when not explicitly passed to EctoSessions.get_session and EctoSessions.get_session! . When true , session extending is attempted automatically after retrieving a single session. Set to false to prevent this behaviour. Runtime configuration, defaults to true . Should only be set if extend_session_stale_time is not nil . See extend_session_stale_time above for more information.","ref":"EctoSessions.Config.html","title":"EctoSessions.Config","type":"behaviour"},{"doc":"Returns the config auth_token_length .","ref":"EctoSessions.Config.html#c:get_auth_token_length/0","title":"EctoSessions.Config.get_auth_token_length/0","type":"callback"},{"doc":"Returns the config auto_extend_session .","ref":"EctoSessions.Config.html#c:get_auto_extend_session/0","title":"EctoSessions.Config.get_auto_extend_session/0","type":"callback"},{"doc":"Returns the config extend_session_stale_time .","ref":"EctoSessions.Config.html#c:get_extend_session_stale_time/0","title":"EctoSessions.Config.get_extend_session_stale_time/0","type":"callback"},{"doc":"Returns the config hashing_algorithm .","ref":"EctoSessions.Config.html#c:get_hashing_algorithm/0","title":"EctoSessions.Config.get_hashing_algorithm/0","type":"callback"},{"doc":"Returns the config secret_salt .","ref":"EctoSessions.Config.html#c:get_secret_salt/0","title":"EctoSessions.Config.get_secret_salt/0","type":"callback"},{"doc":"Returns the config session_ttl .","ref":"EctoSessions.Config.html#c:get_session_ttl/0","title":"EctoSessions.Config.get_session_ttl/0","type":"callback"},{"doc":"GenServer implementation to delete expired sessions periodically. Given an EctoSessions module and periodicity, in milliseconds. Usage In your project's application.ex : def start ( _type , _args ) do children = [ # ... { EctoSessions.ExpiredSessionPruner , { YourSessionsModule , :timer . hours ( 24 ) } } ] opts = [ strategy : :one_for_one , name : EctoSessionsDemo.Supervisor ] Supervisor . start_link ( children , opts ) end Low level usage with start_link : GenServer . start_link ( EctoSessions.ExpiredSessionPruner , { YourSessionsModule , 10_000 } ) Where YourSessionsModule is any module that uses EctoSessions and the second argument the number of milliseconds to 'sleep' between cycles. Ex: 12 * 60 * 60 * 1000 for 12h. Use :timer for readability.","ref":"EctoSessions.ExpiredSessionPruner.html","title":"EctoSessions.ExpiredSessionPruner","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"EctoSessions.ExpiredSessionPruner.html#child_spec/1","title":"EctoSessions.ExpiredSessionPruner.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"EctoSessions.ExpiredSessionPruner.html#init/1","title":"EctoSessions.ExpiredSessionPruner.init/1","type":"function"},{"doc":"","ref":"EctoSessions.ExpiredSessionPruner.html#start_link/1","title":"EctoSessions.ExpiredSessionPruner.start_link/1","type":"function"},{"doc":"Module to help you handle database migrations for EctoSessions . If you are just starting use this interface instead of calling migrations directly. How-to Create a migration with mix ecto.gen.migration AddEctoSessions , then paste the following: defmodule MyApp.Repo.Migrations.AddEctoSessions do use Ecto.Migration alias EctoSessions.Migrations def up , do : Migrations . up ( table_name : &quot;sessions&quot; , extra_fields : [ { :user_id , :string } ] , create_extra_field_indexes : true ) def down , do : Migrations . down ( ) end Tweak the options according to your EctoSessions setup.","ref":"EctoSessions.Migrations.html","title":"EctoSessions.Migrations","type":"module"},{"doc":"","ref":"EctoSessions.Migrations.html#down/1","title":"EctoSessions.Migrations.down/1","type":"function"},{"doc":"Migrates EctoSessions up. Options: prefix : The database prefix, as documented in Ecto.Repo , default to public create_schema : If the schema should be created. table_name : The session table name, defaults to sessions . extra_fields : A list of tuples for the extra fields to create. Defaults to [user_id: :string] . create_extra_field_indexes : true to create unique indexes for the extra fields. Defaults to true .","ref":"EctoSessions.Migrations.html#up/1","title":"EctoSessions.Migrations.up/1","type":"function"},{"doc":"","ref":"EctoSessions.Session.html","title":"EctoSessions.Session","type":"module"},{"doc":"Session is an Ecto schema with: id : a unique identifier of the session. This should be used by your application for internal purposes (ex: references, logs, etc), and not exposed to the end user. auth_token_digest : Random hashed token (or not, according to the configuration). auth_token : A virtual field available ony upon Session creation. It contains the plaintext version of the auth_token_digest . data : any data that your application needs to store for this session. Ex: user id, device name or even ui theme. Any other field defined under extra_fields . Ex: [ {:user_id, :string}, {:role, :string} ] Virtual is_expired , true if the session is not expired. By default if you have used EctoSessions in your project, import it with: alias MyApp.EctoSessions.Session","ref":"EctoSessions.Session.html#__using__/1","title":"EctoSessions.Session.__using__/1","type":"macro"},{"doc":"Database backend sessions with Ecto. ecto_sessions helps you easily and securely manage database backed sessions in your Ecto project. It might be used, for example to manage authorization via cookies or API keys. The medium you will use the sessions is up to the application implementation. Ex: session id to be used in a Cookie or X-Api-Token for a REST API. Using database backed session, might be very helpful in some scenarios. It has quite a few benefits and drawbacks comparing to signed sessions, for example JWT or signed cookies. It might also be used in combination with them. Advantages: Ability to query active sessions for a given user. Ex: list the devices where a user has a valid session or lit the active API keys for a given project. Full control of the validity: at any time your application will be able to control if a given session is valid, change their expiration and even revalidate expired tokens. Ability to store arbitrary data, without increasing the token size. Ex: Device/token name, permissions, metadata, etc. Disadvantages: Depending on the design, you might be adding a database query on each request - just like traditional sessions; Note that you can use a separate database, and furthermore this code might also be adapted for different backends, like key-value stores. Clients and other services will not be able to inspect the contents of the token. This might be useful for example to predict if a token is expired before making a request. This might also be considered an advantage in scenarios you don't want to give any control to the client. One design that allows you to have the benefits of stateless and stateful sessions combined, is to have short-lived signed tokens , and database backed sessions for long-lived refresh tokens .","ref":"readme.html","title":"Ecto Sessions","type":"extras"},{"doc":"This repository includes a full phoenix demo project inside the ./demo directory. There's a hosted live version available at ecto-sessions-demo.tofran.com , feel free to play with it and see how it works/what features it enables.","ref":"readme.html#demo","title":"Ecto Sessions - Demo","type":"extras"},{"doc":"The package can be installed by adding ecto_sessions to your list of dependencies in mix.exs : def deps do [ { :ecto_sessions , &quot;&gt; 0.0.0&quot; } ] end Then, in your ecto app create the following module: defmodule MyApp.Sessions do use EctoSessions , repo : MyApp.Repo end Refer to EctoSessions module documentation for more details.","ref":"readme.html#installation","title":"Ecto Sessions - Installation","type":"extras"}]